function dualac = getdualac(x,di,pd,lambda,tau,method,Ac)
% kind = 0 for l_0
% kind in (0,1) for bridge
% kind = 1 for l_1 (the only convex cace)
% kind = 2 for scad
% kind = 3 for mcp
% kind = 4 for capped-l_1
lac = length(Ac);
if method == 0
    dualac = zeros(lac,1);
elseif 0<method && method<1
    dualac = zeros(lac,1);
    tempx = x(Ac);
    Tstar=(2*lambda*(1-tau))^(1/(2-tau));
    tempid = find(tempx>=Tstar);
    dualac(tempid) = - lambda*tau*(abs(tempx(tempid))).^tau./(tempx(tempid)); 
elseif method == 1
    dualac = lambda*sign(pd(Ac));
elseif method == 2 
    dualac = zeros(lac,1);
    temppd = pd(Ac);
    tempx = x(Ac);
    dii=di(Ac);
    id11 = find(abs(temppd) <= 2*lambda);
    id12 =  find(abs(temppd) >lambda);
    id13 = find (tempx.*dii>=0);
    id14 = intersect(id11,id12);
    id1 = intersect(id13,id14);
    id21 = find(abs(temppd)>2*lambda);
    id22 = find(abs(temppd)< tau*lambda);
    id23 = find (tempx.*dii>=0);
    id24 = intersect(id21,id22);
    id2 = intersect(id23,id24);
    dualac(id1) = lambda*sign(temppd(id1));
    dualac(id2) = (tau*lambda*sign(temppd(id2))-tempx(id2))/(tau-1);
elseif method == 3
    dualac = zeros(lac,1);
    temppd = pd(Ac);
    tempx = x(Ac);
    dii=di(Ac);
    id1 = find( abs(temppd)> lambda);
    id2 = find(abs(temppd)< tau*lambda);
    id3 = find (tempx.*dii>=0);
    id4 = intersect(id1,id2);
    id =intersect(id3,id4);
    dualac(id) = (lambda*sign(temppd(id))-tempx(id))/tau; 
elseif method == 4
    dualac = zeros(lac,1);
    temppd = pd(Ac);
    id1 = find( abs(temppd)>lambda);
    id2 = find(abs(temppd)< (tau+0.5)*lambda);
    id = intersect(id1,id2);
    dualac(id) = lambda*sign(temppd(id)); 
end